//
//  WMTableViewController.m
//  MasonyDemo
//
//  Created by wangmiao on 16/4/27.
//  Copyright © 2016年 wangmiao. All rights reserved.
//

#import "WMTableViewController.h"
#import "WMNormalViewController.h"
#import "WMSimpleViewController.h"
#import "WMComplicatedViewController.h"
#import "WMSeniorViewController.h"

@interface WMTableViewController ()

@property (nonatomic, strong) NSMutableArray  *  dataSource;

@end

@implementation WMTableViewController


- (NSMutableArray *)dataSource
{
    if (!_dataSource) {
        _dataSource = [NSMutableArray array];
    }
    return _dataSource;
}


- (void)viewDidLoad {
    [super viewDidLoad];
    NSArray *array = @[@"基础", @"初级", @"中级", @"高级"];
    self.dataSource = [NSMutableArray arrayWithArray:array];
    self.automaticallyAdjustsScrollViewInsets = YES;
//    self.tableView.contentInset = UIEdgeInsetsMake(20, 0, 0, 0);
}



#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return self.dataSource.count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *ID = @"Masonry";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:ID];
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:ID];
    }
    
    cell.textLabel.text = self.dataSource[indexPath.row];
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.row == 0) {
        WMNormalViewController *vc = [[WMNormalViewController alloc] init];
        [self.navigationController pushViewController:vc animated:YES];
    } else if (indexPath.row == 1) {
        WMSimpleViewController *vc = [[WMSimpleViewController alloc] init];
        [self.navigationController pushViewController:vc animated:YES];
    } else if (indexPath.row == 2) {
        WMComplicatedViewController * vc = [[WMComplicatedViewController alloc] init];
        [self.navigationController pushViewController:vc animated:YES];
    } else if (indexPath.row == 3) {
        WMSeniorViewController *vc = [[WMSeniorViewController alloc] init];
        [self.navigationController pushViewController:vc animated:YES];
    }
}

@end
